using Avalonia.Controls;
using Avalonia.Interactivity;
using Calendar;
using SkiaSharp;
using System;
using System.Runtime.Intrinsics.Arm;
using static System.Runtime.InteropServices.JavaScript.JSType;

namespace Calendar
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void GetData(object sender, RoutedEventArgs e)
        {
            string date = dp.SelectedDate.ToString();
            DateTime bithday = Convert.ToDateTime(date);
            DateTime today = DateTime.Now;
            if (today<bithday)
            {
                error.Text = "   .  .";
            }
            else
            {
                YearMonthDay(bithday, today);
                int dayOfBith = Convert.ToInt32(bithday.DayOfWeek);
                DayOfTheWeek(bithday, today, dayOfBith);
                LeapYear(bithday, today, dayOfBith);
            }
        }

        private void ChineseHoroscope(object sender, RoutedEventArgs e)
        {
            string date = dp.SelectedDate.ToString();
            if (date == "")
            {
                textAnimal.Text = "   .";
            }
            else
            {
                DateTime bithday = Convert.ToDateTime(date);
                float bithdayYear = bithday.Year;
                float chiHoro = bithdayYear / 12;
                int chiHoroInt = Convert.ToInt32(Math.Floor(chiHoro));
                chiHoro = 0 + (chiHoro - chiHoroInt);
                chiHoro = Convert.ToInt32(chiHoro * 12);

                if (chiHoro == 0) textAnimal.Text = "  :";
                else if (chiHoro == 1) textAnimal.Text = "  : ";
                else if (chiHoro == 2) textAnimal.Text = "  : ";
                else if (chiHoro == 3) textAnimal.Text = "  : ";
                else if (chiHoro == 4) textAnimal.Text = "  : ";
                else if (chiHoro == 5) textAnimal.Text = "  : ";
                else if (chiHoro == 6) textAnimal.Text = "  : ";
                else if (chiHoro == 7) textAnimal.Text = "  : ";
                else if (chiHoro == 8) textAnimal.Text = "  : ";
                else if (chiHoro == 9) textAnimal.Text = "  : ";
                else if (chiHoro == 10) textAnimal.Text = "  : ";
                else if (chiHoro == 11) textAnimal.Text = "  : ";
            }
        }

        private void ZodiacHoroscope(object sender, RoutedEventArgs e)
        {
            string date = dp.SelectedDate.ToString();
            if (date == "")
            {
                textAnimal.Text = "   .";
            }
            else
            {
                DateTime bithday = Convert.ToDateTime(date);
                string imageAnimalSource;
                if ((bithday.Day >= 21 && bithday.Day <= 31 && bithday.Month == 3) || (bithday.Day >= 1 && bithday.Day <= 19 && bithday.Month == 4))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 20 && bithday.Day <= 30 && bithday.Month == 4) || (bithday.Day >= 1 && bithday.Day <= 20 && bithday.Month == 5))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 21 && bithday.Day <= 31 && bithday.Month == 5) || (bithday.Day >= 1 && bithday.Day <= 21 && bithday.Month == 6))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 22 && bithday.Day <= 30 && bithday.Month == 6) || (bithday.Day >= 1 && bithday.Day <= 22 && bithday.Month == 7))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 23 && bithday.Day <= 31 && bithday.Month == 7) || (bithday.Day >= 1 && bithday.Day <= 22 && bithday.Month == 8))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 23 && bithday.Day <= 31 && bithday.Month == 8) || (bithday.Day >= 1 && bithday.Day <= 22 && bithday.Month == 9))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 23 && bithday.Day <= 30 && bithday.Month == 9) || (bithday.Day >= 1 && bithday.Day <= 23 && bithday.Month == 10))
                    textAnimal.Text = "  :  ";
                if ((bithday.Day >= 24 && bithday.Day <= 31 && bithday.Month == 10) || (bithday.Day >= 1 && bithday.Day <= 21 && bithday.Month == 11))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 22 && bithday.Day <= 30 && bithday.Month == 11) || (bithday.Day >= 1 && bithday.Day <= 21 && bithday.Month == 12))
                    textAnimal.Text = "  :  ";
                if ((bithday.Day >= 22 && bithday.Day <= 31 && bithday.Month == 12) || (bithday.Day >= 1 && bithday.Day <= 20 && bithday.Month == 1))
                    textAnimal.Text = "  :  ";
                if ((bithday.Day >= 21 && bithday.Day <= 31 && bithday.Month == 1) || (bithday.Day >= 1 && bithday.Day <= 20 && bithday.Month == 2))
                    textAnimal.Text = "  : ";
                if ((bithday.Day >= 21 && bithday.Day <= 29 && bithday.Month == 2) || (bithday.Day >= 1 && bithday.Day <= 20 && bithday.Month == 3))
                    textAnimal.Text = "  : ";
            }
        }

        public void YearMonthDay(DateTime bithday, DateTime today)
        {
            int ageDaysAll = (today - bithday).Days;
            int ageYears = today.Year - bithday.Year;
            int ageMonth = today.Month - bithday.Month;
            int ageDays = today.Day - bithday.Day;

            DateTime thisBith = new DateTime(today.Year, bithday.Month, bithday.Day);
            int daysBeforeBith = (thisBith - bithday).Days;

            if (daysBeforeBith > ageDaysAll) ageYears = ageYears - 1;

            if ((ageMonth == 0 && ageDays < 0) || ageMonth < 0)
            {
                ageMonth = 12 + ageMonth;
            }

            if (ageDays < 0)
            {
                ageMonth--;
                ageYears--;
                int daysInMonth = System.DateTime.DaysInMonth(today.Year, today.Month);
                ageDays = daysInMonth + ageDays;
            }

            years.Text = Convert.ToString(ageYears);
            month.Text = Convert.ToString(ageMonth);
            days.Text = Convert.ToString(ageDays);
        }

        public void DayOfTheWeek(DateTime bithday, DateTime today, int dayOfBith)
        {
            if (dayOfBith == 0)
            {
                dayOfWeek.Text = "";
            }
            else if (dayOfBith == 1)
            {
                dayOfWeek.Text = "";
            }
            else if (dayOfBith == 2)
            {
                dayOfWeek.Text = "";
                week.Text = "  ";
            }
            else if (dayOfBith == 3)
            {
                dayOfWeek.Text = "";
            }
            else if (dayOfBith == 4)
            {
                dayOfWeek.Text = "";
            }
            else if (dayOfBith == 5)
            {
                dayOfWeek.Text = "";
            }
            else if (dayOfBith == 6)
            {
                dayOfWeek.Text = "";
            }

            int count = 0;
            for (int year = bithday.Year; year <= today.Year; year++)
            {
                DateTime myDate = new DateTime(year, bithday.Month, bithday.Day);
                if (Convert.ToInt32(myDate.DayOfWeek) == dayOfBith)
                {
                    count++;
                }
            }

            dayCount.Text = Convert.ToString(count);
        }

        public void LeapYear(DateTime bithday, DateTime today, int dayOfBith)
        {
            
            int countLeapYear = 0;
            string LeapYears = "";
            for (int year = bithday.Year; year < today.Year; year++)
            {
                DateTime myDate = new DateTime(year, 12, 31);
                if (myDate.DayOfYear == 366)
                {
                    countLeapYear++;
                    LeapYears = LeapYears + " " + Convert.ToString(year);
                }
            }
            
            countLY.Text = Convert.ToString(countLeapYear);
            leapYears.Text = LeapYears;
        }
    }
}